<?php

$cms['modules']['pages.mod.php'] = array(
    'name' => __('Pages', 'pages.mod.php'),
    'description' => __('Module for edditing pages', 'pages.mod.php'),
    'url_title' => __('Module page'),
    'url_link' => 'https://coffee-cms.com/modules/pages/',
    'author' => __('Coffee CMS team'),
    'version' => '20.05',
    'files' => array(
        '.cms/mod/pages.mod.php',
        '.cms/js/pages.js',
    ),
    'sort'    => 20,
);

// Return if module disabled
if ( isset($cms['config']['pages.mod.php']['disabled'])
&& $cms['config']['pages.mod.php']['disabled'] === true ) return;


cms_add_function('create_tables', 'cms_pages_create_tables');
cms_add_function('query', 'cms_pages_query');
cms_add_function('admin', 'cms_pages_admin');
cms_add_function('ajax', 'cms_pages_ajax');
cms_add_function('admin_header', function () {
    global $cms;
    if ( isset($cms['config']['pages.mod.php']['disabled'])
    && $cms['config']['pages.mod.php']['disabled'] === true ) return;
    echo "
        <script type=text/javascript>
            \$conn_lost = '".__('Connection lost.', 'pages.mod.php')."';
            \$q_delete = '".__('Delete?', 'pages.mod.php')."';
        </script>
    ";
});


function cms_pages_ajax() {
    global $cms;
    if (!is_admin()) return;
    if (empty($cms['base'])) cms_base_connect();
    if (!empty($_POST['fn'])) {
        
        switch ($_POST['fn']) {

            case 'create_page':
                $cms['status'] = '200';
                /* Определить URL родительской */
                if ( $pid = (int) $_POST['pid'] ) {
                    $q = "SELECT url FROM pages WHERE id='{$pid}'";
                    if ( $r = mysqli_query( $cms['base'], $q ) ) {
                        $parent = mysqli_fetch_assoc( $r );
                    }
                } else {
                    $parent['url'] = $cms['base_url'];
                }
                
                /* Вставить в базу и получить id */
                $created = date('Y-m-d H:i:s');
                $type = 'page';
                $q = "INSERT INTO pages SET created='{$created}', type='{$type}', pid={$pid}";
                if ( $r = mysqli_query( $cms['base'], $q ) ) {
                    $id = mysqli_insert_id( $cms['base'] );
                } else {
                    exit( json_encode( array(
                        'info_text'  => __('Error creating page: ', 'pages.mod.php') . mysqli_error( $cms['base'] ),
                        'info_class' => 'info-error',
                        'info_time'  => 5000,
                    ) ) );
                }

                /* Создать заголовок, url и обновить в базе */
                $title     = mysqli_real_escape_string( $cms['base'], __('Page', 'pages.mod.php') . ' ' . $id );
                $short_url = strtolower( cms_translit( __('Page', 'pages.mod.php') . ' ' . $id ) );
                $url       = mysqli_real_escape_string( $cms['base'], $parent['url'] . $short_url . '/' );
                //$short_url = mysqli_real_escape_string( $cms['base'], $short_url );
                $short_url = '';
                if (strlen($_POST['sort'])) {
                    if ($_POST['sort2']) {
                        $sort = (int)(( $_POST['sort'] + $_POST['sort2'] ) / 2);
                    } else {
                        $sort = $_POST['sort'] + 10;
                    }
                } else {
                    $sort      = $id * 10;
                }
                $q = "UPDATE pages SET title='{$title}', short_url='{$short_url}', url='{$url}', sort={$sort} WHERE id={$id}";
                if ( $r = mysqli_query( $cms['base'], $q ) ) {
                    exit( json_encode( array(
                        'info_text'  => __('Page created', 'pages.mod.php'),
                        'info_class' => 'info-success',
                        'info_time'  => 1000,
                        'list'       => cms_pages_get_pages_list(),
                        'parents'    => cms_pages_get_parents_list(),
                    ) ) );
                } else {
                    exit( json_encode( array(
                        'info_text'  => __('Error creating page', 'pages.mod.php'),
                        'info_class' => 'info-error',
                        'info_time'  => 5000,
                    ) ) );
                }
            break;

            case 'save_prop':
                $cms['status'] = '200';
                cms_clear_cache();
                $id          = (int) $_POST['id'];
                $pid         = (int) $_POST['pid'];
                $sort        = (int) $_POST['sort'];
                $title       = mysqli_real_escape_string( $cms['base'], $_POST['title'] );
                $seo_title   = mysqli_real_escape_string( $cms['base'], $_POST['seo_title'] );
                $description = mysqli_real_escape_string( $cms['base'], $_POST['description'] );

                // Извлекаем настройки для сравнения
                $q = "SELECT id, pid, type_url, short_url, sort, created FROM pages WHERE id={$id}";
                if ( $r = mysqli_query( $cms['base'], $q ) ) {
                    $page = mysqli_fetch_assoc( $r );
                    // Есть ли дочерние
                    $q = "SELECT id FROM pages WHERE pid={$id} LIMIT 1";
                    $r = mysqli_query( $cms['base'], $q );
                    $page['has_child'] = mysqli_fetch_assoc( $r );
                } else {
                    exit( json_encode( array(
                        'info_text'  => 'Такая страница не найдена',
                        'info_class' => 'info-error',
                        'info_time'  => 5000,
                    ) ) );
                }

                // Нужно обновлять весь список если изменился:
                // - родитель страницы
                // - сортировка
                $update_list = false;
                if ( $pid != $page['pid'] || $sort != $page['sort'] ) {
                    $update_list = true;
                }


                // Короткий URL
                if ( $_POST['type_url'] === 'auto' ) {
                    // Определяем URL родителя
                    $q = "SELECT url FROM pages WHERE id={$pid}";
                    if ( $r = mysqli_query( $cms['base'], $q ) ) {
                        $parent = mysqli_fetch_assoc( $r );
                    } else {
                        $parent['url'] = $cms['base_url'];
                    }
                    if ( substr( $parent['url'], 0, 1 ) !== '/' ) { $parent['url']  = '/' . $parent['url']; }
                    if ( substr( $parent['url'], -1 )   !== '/' ) { $parent['url'] .= '/'; }
                    // Если короткий url не задан, то создаем из заголовка
                    if ( empty( $_POST['url'] ) ) {
                        $_POST['url'] = strtolower( cms_translit( $_POST['title'] ) );
                    }
                    //$_POST['url'] = strtr( $_POST['url'], array( '.' => '' ) );
                    $short_url = mysqli_real_escape_string( $cms['base'], $_POST['url'] );
                    $new_url   = $parent['url'] . $_POST['url'] . '/';
                    $new_url   = strtr( $new_url, array( '///' => '/' ) );
                    $url       = mysqli_real_escape_string( $cms['base'], $new_url );
                    // Check dupl
                    if ( $r = mysqli_query( $cms['base'], "SELECT COUNT(*) FROM pages WHERE url='{$url}' AND id<>{$id}" ) ) {
                        if ( $cnt = mysqli_fetch_assoc( $r ) ) {
                            if ( $cnt['COUNT(*)'] > 0 ) {
                                exit( json_encode( array(
                                    'info_text'  => __('Duplicate URL.', 'pages.mod.php'),
                                    'info_class' => 'info-error',
                                    'info_time'  => 5000,
                                ) ) );
                            }
                        }
                    }
                    $update_url = " short_url='{$short_url}', url='{$url}' ";
                    // Изменить URL у дочерних, только у тех у кого auto
                    $q = "SELECT id, short_url, url FROM pages WHERE pid=$id AND type_url='auto'";
                    if ( $r = mysqli_query( $cms['base'], $q ) ) {
                        while ( $child = mysqli_fetch_assoc( $r ) ) {
                            $child_url = $parent['url'] . $_POST['url'] . '/' . $child['short_url'] . '/';
                                // Обновить весь список если изменился url дочерней страницы
                                if ( $child_url !== $child['url'] ) {
                                    $update_list = true;
                                }
                            $child_url = mysqli_real_escape_string( $cms['base'], $child_url );
                            mysqli_query( $cms['base'], "UPDATE pages SET url='{$child_url}' WHERE id={$child['id']}" );
                        }
                    }
                } elseif ( $_POST['type_url'] === 'manual' ) {
                    # Полный URL
                    # ...
                }

                if ( empty( $_POST['date'] ) ) { $_POST['date'] = '0000-00-00'; }
                if ( empty( $_POST['time'] ) ) { $_POST['time'] = '00:00'; }
                $created   = $_POST['date'] . ' ' . $_POST['time'].':00';
                if ( $page['created'] !== $created ) {
                    $terminator = date('Y-m-d H:i:s');
                    if ( $page['created'] < $terminator && $terminator <= $created ) {
                        $update_list = true;
                    }
                    if ( $created < $terminator && $terminator <= $page['created'] ) {
                        $update_list = true;
                    }
                }
                $tpl       = $_POST['template'];
                $q = "UPDATE pages SET 
                        title='{$title}', 
                        seo_title='{$seo_title}', 
                        description='{$description}', 
                        sort={$sort}, 
                        created='{$created}', 
                        type='{$tpl}', 
                        pid={$pid},
                        {$update_url}
                      WHERE id={$id}";
                if ( $r = mysqli_query( $cms['base'], $q ) ) {
                    // Создать кеш
                    cms_create_cache();
                    $r = array(
                        'info_text'  => __('Updated', 'pages.mod.php'),
                        'info_class' => 'info-success',
                        'info_time'  => 1000,
                        'title'      => htmlspecialchars( $_POST['title'] ),
                        'short_url'  => $_POST['url'],
                        'new_url'    => $new_url,
                    );
                    if ( $update_list ) {
                        $r['list']    = cms_pages_get_pages_list();
                        $r['parents'] = cms_pages_get_parents_list();
                    }
                    if ( function_exists( "cms_sitemap_generate" ) ) {
                        cms_sitemap_generate();
                    }
                    exit ( json_encode( $r ) );
                } else {
                    exit( json_encode( array(
                        'info_text'  => __('Error update properties', 'pages.mod.php').mysqli_error( $cms['base'] ),
                        'info_class' => 'info-error',
                        'info_time'  => 5000,
                    ) ) );
                }
            break;

            case 'save_page':
                $cms['status'] = '200';
                if ( empty( $_POST['id'] ) ) {
                    exit( json_encode( array(
                        'info_text'  => __('Empty page id', 'pages.mod.php'),
                        'info_class' => 'info-error',
                        'info_time'  => 3000,
                    ) ) );
                }
                if ( $_POST['text'] === NULL ) {
                    exit( json_encode( array(
                        'info_text' => 'NULL text error. Line: '.__LINE__,
                        'info_class' => 'info-error',
                        'info_time'  => 20000,
                    ) ) );
                }
                // hook for save page
                cms_do_stage('save_page');
                
                $id           = (int) $_POST['id'];
                $old_modified = str_replace(',', '.', (float)$_POST['modified']);
                $modified     = str_replace(',', '.', microtime(true));
                $text         = mysqli_real_escape_string( $cms['base'], $_POST['text'] );
                $q = "UPDATE pages SET text='{$text}', modified={$modified} WHERE id={$id} AND modified={$old_modified}";
                if ( mysqli_query( $cms['base'], $q ) ) {
                    if ( !mysqli_affected_rows( $cms['base'] ) ) {
                        exit( json_encode( array(
                            'info_text' => __('Someone already changed the page', 'pages.mod.php'),
                            'info_class' => 'info-error',
                            'info_time'  => 5000,
                        ) ) );
                    }

                    # Удалить старую страницу
                    if ( substr( $_POST['url'], -1, 1 ) === '/' ) {
                        $_POST['url'] .= 'index.html';
                    }
                    $old_file = $cms['site_dir'] . $_POST['url'];
                    if ( file_exists( $old_file ) ) unlink($old_file);
                    if ( function_exists( "cms_sitemap_generate" ) ) {
                        cms_sitemap_generate();
                    }
                    exit( json_encode( array(
                        'info_text'  => 'Сохранено',
                        'info_class' => 'info-success',
                        'info_time'  => 3000,
                        'modified'   => $modified,
                    ) ) );
                } else {
                    exit( json_encode( array(
                        'info_text'  => __('Query error. Line:', 'pages.mod.php').__LINE__.__(' Query:', 'pages.mod.php').$q,
                        'info_class' => 'info-error',
                        'info_time'  => 0,
                    ) ) );
                }
            break;

            case 'get_page':
                $cms['status'] = '200';
                if ( $id = (int)$_POST['id'] and $res = mysqli_query( $cms['base'], "SELECT * FROM pages WHERE id={$id}" ) ) {
                    if ( $page = mysqli_fetch_assoc( $res ) ) {
                        echo json_encode( array(
                            'result' => 'ok',
                            'page'   => $page,
                        ) );
                    } else {
                        echo json_encode( array( 'result' => 'false' ) );
                    }
                }
            break;

            case 'get_pages_list':
                $cms['status'] = '200';
                exit( json_encode( array(
                    'list'    => cms_pages_get_pages_list(),
                    'parents' => cms_pages_get_parents_list(),
                ) ) );
            break;

            case 'del_page':
                $cms['status'] = '200';
                if ( $id = (int) $_POST['id'] ) {
                    /* Удалить весь кеш */
                    cms_clear_cache();

                    if ( $res = mysqli_query( $cms['base'], "SELECT pid FROM pages WHERE id=$id" ) and $page = mysqli_fetch_assoc($res) ) {

                        /* Определить URL родительской */
                        if ( $page['pid'] ) {
                            $q = "SELECT url FROM pages WHERE id='{$page['pid']}'";
                            if ( $r = mysqli_query( $cms['base'], $q ) ) {
                                $parent = mysqli_fetch_assoc( $r );
                            }
                        } else {
                            $parent['url'] = $cms['base_url'];
                        }
                        
                        /* Изменить родителя и URL у дочерних */
                        if ( $r = mysqli_query( $cms['base'], "SELECT id, type_url, short_url FROM pages WHERE pid=$id" ) ) {
                            while ( $child = mysqli_fetch_assoc( $r ) ) {
                                if ( $child['type_url'] === 'auto' ) {
                                    $url     = mysqli_real_escape_string( $cms['base'], $parent['url'] . $child['short_url'] . '/' );
                                    $set_url = ", url='{$url}'";
                                } else {
                                    $set_url = '';
                                }
                                mysqli_query( $cms['base'], "UPDATE pages SET pid={$page['pid']} {$set_url} WHERE id={$child['id']}" );
                            }
                        }

                        /* Удалить страницу из базы */
                        mysqli_query( $cms['base'], "DELETE FROM pages WHERE id=$id" );

                        /* Создать кеш */
                        cms_create_cache();
                        exit( json_encode( array(
                            'info_text'  => 'Страница удалена',
                            'info_class' => 'info-success',
                            'info_time'  => 1000,
                            'list'       => cms_pages_get_pages_list(),
                            'parents'    => cms_pages_get_parents_list(),
                        ) ) );

                    } else {
                        exit( json_encode( array(
                            'info_text'  => 'Ошибка удаления страницы: ' . mysqli_error( $cms['base'] ),
                            'info_class' => 'info-error',
                            'info_time'  => 5000,
                        ) ) );
                    }
                } else {
                    exit( json_encode( array(
                        'info_text'  => 'Ошибка удаления страницы: неверный id',
                        'info_class' => 'info-error',
                        'info_time'  => 5000,
                    ) ) );
                }
            break;

            case 'recreate_cache':
                $cms['status'] = '200';
                cms_clear_cache();
                cms_create_cache();
                exit( json_encode( array(
                    'info_text'  => __('Cache Updated', 'pages.mod.php'),
                    'info_class' => 'info-success',
                    'info_time'  => 1000,
                ) ) );
            break;
        }
    }
}

# Возвращает список <option> для выбора родительской страницы
function cms_pages_get_parents_list( $pid = 0, $lvl = 0 ) {
    global $cms;
    $pref = str_repeat("&emsp;&emsp;", $lvl);
    $parents = '';
    if ( $res = mysqli_query( $cms['base'], "SELECT id, pid, title, url FROM pages WHERE pid='{$pid}' ORDER BY title" ) ) {
        while ( $page = mysqli_fetch_assoc( $res ) ) {
            $title = htmlspecialchars( $page['title'] );
            $parents .= "<option value='{$page['id']}' data-url='{$page['url']}'>{$pref}{$title}</option>";
            $parents .= cms_pages_get_parents_list( $page['id'], $lvl+1 );
        }
    }
    return $parents;
}

# Возвращает список <option> для выбора подшаблона из текущего шаблона
function cms_pages_get_templates_list() {
    global $cms;
    $templates = '';
    $expr = $cms['cms_dir'] . '/' . $cms['config']['template.mod.php']['template'] . '/html-*.php';
    foreach ( glob( $expr ) as $tpl ) {
        $name = preg_replace( '/.+\/html-(.+)\.php/', '$1', $tpl );
        $templates .= "<option value='{$name}'>{$name}</option>";
    }
    return $templates;
}

# Создает иерархический список страниц для админки
function cms_pages_get_pages_list( $pid = 0 ) {
    global $cms;
    $templates = cms_pages_get_templates_list();
    $list = '';
    if ( !empty( $cms['base'] ) and $res = mysqli_query( $cms['base'], "SELECT id, pid, title, seo_title, description, created, type_url, short_url, url, type, sort FROM pages WHERE pid={$pid} ORDER BY sort, title" ) ) {
        while ( $page = mysqli_fetch_assoc( $res ) ) {
            if ( $page['created'] === '0000-00-00 00:00:00' ) {
                $created = __("no date", 'pages.mod.php');
                $date    = '';
                $time    = '';
                $published = 'Published';
                $class = 'zero';
            } else {
                $time = strtotime( $page['created'] );
                if ( time() >= $time ) {
                    $published = 'Published';
                    $class     = 'published';
                } else {
                    $published = 'Planned';
                    $class     = 'planned';
                }
                $created = date( 'd.m.Y H:i', $time );
                $date    = date( 'Y-m-d', $time );
                $time    = date( 'H:i', $time );
            }
            if ( $page['type_url'] === 'auto' ) {
                $url = $page['short_url'];
            } elseif ( $page['type_url'] === 'manual' ) {
                $url = $page['url'];
            }
            $list   .= "
                <div class='pages-box' data-page-box>
                    
                    <div class='hotsetting' data-page-prop={$page['id']}>
                        <h1 class='hotsetting'>".__("PAGE PROPERTIES", 'pages.mod.php')."</h1>
                        <div class='sett-grid-container'>
                        
                            <div class='Sett-LeftGrid'>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('Title', 'pages.mod.php').":</div>
                                    <div><input data-page-id={$page['id']} name='title' type='text' class='settingx' value='{$page['title']}'></div>
                                </div>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('Label / URL', 'pages.mod.php').":</div>
                                    <div><input data-page-id={$page['id']} name='url' type='text' class='settingx' value='{$url}' data-page-url-type='{$page['type_url']}'></div>
                                </div>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('SEO Title', 'pages.mod.php').":</div>
                                    <div><input data-page-id={$page['id']} name='seo_title' type='text' class='settingx' value='{$page['seo_title']}'></div>
                                </div>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('Description', 'pages.mod.php').":</div>
                                    <div><textarea data-page-id={$page['id']} name='description' class='settingx' rows='2'>{$page['description']}</textarea></div>
                                </div>
                            </div>
                        
                            <div class='Sett-RightGrid'>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('Parent', 'pages.mod.php').":</div>
                                    <div class=select2-wrapper>
                                        <select data-page-parent={$page['pid']} class='settingx-right parents-list' data-page-id={$page['id']} name=pid>
                                            <option value='0'>".__('No parent', 'pages.mod.php')."</option>
                                        </select>
                                    </div>
                                </div>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('Template', 'pages.mod.php').":</div>
                                    <div class=select2-wrapper>
                                        <select class='settingx-right templates-list' data-page-template='{$page['type']}' data-page-id={$page['id']} name=template>
                                            <option value=''>".__('No template', 'pages.mod.php')."</option>
                                            {$templates}
                                        </select>
                                    </div>
                                </div>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('Sort', 'pages.mod.php').":</div>
                                    <div><input data-page-id={$page['id']} name='sort' type='text' class='settingx-right-order' value='{$page['sort']}'></div>
                                </div>
                                <div class='sett-attribute'>
                                    <div class='settinput-text'>".__('Date', 'pages.mod.php').":</div>
                                    <div>
                                        <input data-page-id={$page['id']} name='date' type='date' class='settingx-date' value='{$date}'>
                                        <input data-page-id={$page['id']} name='time' type='time' class='settingx-time' value='{$time}'>
                                    </div>
                                </div>
                            </div>
                        
                        </div>
                        
                        <div class='hotbott'>
                            <a href=# data-page-prop-cancel={$page['id']} class='button-close'>".__('Cancel', 'pages.mod.php')."</a>
                            <a href=# data-page-prop-save={$page['id']} class='button-save'>".__('Save', 'pages.mod.php')."</a>
                        </div>
                
                    </div>

                    <div data-page-item={$page['id']} class='cpline style-page'>
                        
                        <h1><a data-page-item-link={$page['id']} href='{$page['url']}' target=_blank>{$page['title']}</a></h1>
                        
                        <div class='admin-pagesetting'>
                            <a href=# class=edit-page data-page-edit-btn={$page['id']}>".__('Edit', 'pages.mod.php')."</a> 
                            <a href=# class=open-prop data-page-prop-open={$page['id']}>".__('Properties', 'pages.mod.php')."</a> 
                            <span class='a-red'><a data-page-del={$page['id']} href=# class=del-page>".__('Delete', 'pages.mod.php')."</a></span> 
                            <a href=# class=create-page data-page-create='{$page['pid']}' data-page-sort='{$page['sort']}'>".__('Add Page', 'pages.mod.php')."</a>
                            <a href=# class=create-page data-page-create='{$page['id']}'>".__('Add Child Page', 'pages.mod.php')."</a>
                        </div>
                        
                        <div class='admin-datapublicline {$class}'>".__($published, 'pages.mod.php')."<br>{$created}</div>
                        <!--
                        <div class='admin-checkpageline'>
                            <input type=checkbox id='checkbox-id-{$page['id']}' name='checked[]' value='1'>
                            <label for=checkbox-id-{$page['id']} class=checkbox></label>
                        </div>
                        -->

                    </div>";
                    if ( $sublist = cms_pages_get_pages_list( $page['id'] ) ) {
                        $list .= "
                            <div class=subbox-grid>
                                {$sublist}
                            </div>
                        ";
                    }
            $list .= "
                </div>
            ";
        }
    } else return mysqli_error($cms['base']);
    $list = preg_replace( '/(\s)+/', '$1', $list );
    return $list;
}


function cms_pages_query() {
    global $cms;
    
    // Если запрашивается файл с диска, то SQL-запрос будет лишним
    if ( is_file( $cms['cms_file'] ) ) return;
    
    if (empty($cms['base'])) return;
    if (mysqli_connect_error()) return;
    $url = mysqli_real_escape_string($cms['base'], $cms['url']);
    if ($res = mysqli_query($cms['base'], "SELECT * FROM pages WHERE url='$url'")) {
        if ($cms['page'] = mysqli_fetch_assoc($res)) {
            if ($cms['page']['created'] <= date('Y-m-d H:i:s')) {
                $cms['status'] = '200';
            } else {
                $cms['status'] = '404'; // disable write to disk
            }
            if ($cms['page']['pid'] !== 0
                and $res_parent = mysqli_query($cms['base'],"SELECT * FROM pages WHERE id='{$cms['page']['pid']}'")
                and $parent = mysqli_fetch_assoc($res_parent))
            {
                    $cms['page']['parent'] = $parent;
            }
        }
    }
}

function cms_pages_create_tables() {
    global $cms;
    mysqli_query($cms['base'], "
    CREATE TABLE `pages` (
        `id` bigint(20) UNSIGNED NOT NULL,
        `pid` int(11) NOT NULL DEFAULT 0,
        `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
        `modified` double NOT NULL DEFAULT 0,
        `type` varchar(64) DEFAULT NULL,
        `title` varchar(255) DEFAULT NULL,
        `seo_title` varchar(255) DEFAULT NULL,
        `text` longtext DEFAULT NULL,
        `type_url` varchar(8) NOT NULL DEFAULT 'auto',
        `short_url` varchar(255) NOT NULL DEFAULT '',
        `url` varchar(255) DEFAULT NULL,
        `keywords` varchar(1024) NOT NULL DEFAULT '',
        `description` varchar(2048) NOT NULL DEFAULT '',
        `sort` int(11) NOT NULL DEFAULT 0
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
");
    mysqli_query($cms['base'], "ALTER TABLE `pages` ADD UNIQUE KEY `id` (`id`);");
    mysqli_query($cms['base'], "ALTER TABLE `pages` MODIFY `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT;");

    // Create Demo Page
    mysqli_query($cms['base'], "INSERT INTO `pages` (`id`, `pid`, `created`, `modified`, `type`, `title`, `seo_title`, `text`, `type_url`, `short_url`, `url`, `keywords`, `description`, `sort`) VALUES
(1, 0, '2020-04-13 21:40:00', 1587157038.9078, 'page', 'Mini', '', '<div class=\"line\">\n	<div class=\"container-banner\"><img src=\"/mini/banner.jpg\"></div>\n</div>\n<div class=\"line\">\n  <div class=\"line-container-text padding-container\">\n	<div class=\"content-text\">\n      <p class=\"paragraph\">Это облегчённый шаблон, созданный для творчества, одновременно является примером и отправной точкой для Вашего проекта.</p>\n      <p class=\"paragraph\">Перед началом использования рекомендуем ознакомиться с документацией по кастомизации тем и шаблонов.</p>\n      <p class=\"paragraph\">Команда Coffee CMS.</p>\n  	</div>\n  </div>\n</div>\n', 'auto', '/', '/', '', '', 0);");
}

function cms_pages_admin() {
    global $cms;
    if (!is_admin()) return;
    $buttons = '';
    $page = "
    <div class=toppanell>
        <div style='position: relative; width: 400px; display: inline-block;'>
            <input data-page-search class=page-search type=text placeholder='".__('Search...', 'pages.mod.php')."'>
            <button class=page-search-button type=submit></button>
        </div>
        <div class=groupmaster-check>
            <input type=checkbox id=0 value=0>
            <!--
            <label title='".__('Select all', 'pages.mod.php')."' for=0 class=checkbox></label>
            -->
        </div>
    </div>

    <div class=wrapper-page-grid data-pages-list>
        <!-- Pages -->
    </div>

    <div class=bottompanell>
        <a class='add-button add-page' href=# data-page-create=0>".__('Add page', 'pages.mod.php')."</a>
    </div>

    <!-- Page editor -->
    <div data-page-editor class='Bg-Page-Editor-Box hidden'>
      <div class=Page-Editor-Box>
        <div class=page-editor-grid>
          <div class=Header-Page>
            <h1><a data-page-title href=# target=_blank id=coffee_page_title>".__('Title', 'pages.mod.php')."</a></h1>
          </div>
          <div class=Settings-Editor>
            <!-- Кнопки для редактора -->
            {$buttons}
          </div>
          <div class=Page-Editor>
            <textarea data-page-text placeholder=Code class=coffee-editorpage-area id=coffee_editorpage-area name=add_editorpage>".__('Text', 'pages.mod.php')."</textarea>
          </div>
          <div class=Button-Box-Page>
            <div class=hotbott-page-editor>
              <a data-page-cancel-btn href=# class=button-close>".__('Cancel', 'pages.mod.php')."</a>
              <a data-page-save-btn href=# class='button-save save'>".__('Save', 'pages.mod.php')."</a>
              <a data-page-save-close-btn href=# class='button-save close'>".__('Save and Close', 'pages.mod.php')."</a>
            </div>
          </div>
        </div>
      </div>
    </div>";

    // Создаем пункт меню, если еще не создан
    if ( empty( $cms['config']['pages.mod.php']['menu']['pages'] ) ) {
        $cms['config']['pages.mod.php']['menu']['pages'] = array(
            'title'    => 'Pages',
            'sort'     => 20,
            'class'    => '',
            'section'  => 'Navigation',
        );
        cms_save_config();
    }

    $cms['admin_pages']['pages'] = $page;
}
